/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>

/*---------------------------------------------------------------------------------------------------------*/
/*  Include hear file   	    				                                                           */
/*---------------------------------------------------------------------------------------------------------*/

#include "NUC1xx.h"

/*----------------------------------------------------------------------------
  Define variable
  ----------------------------------------------------------------------------*/
	static uint32_t WDTCOUN=0;
/*----------------------------------------------------------------------------
  Function subroutine
  ----------------------------------------------------------------------------*/
void Delay(uint32_t delayCnt)
{
    while(delayCnt--)
    {
        __NOP();
        __NOP();
    }
}
/*----------------------------------------------------------------------------
  Interrupt subroutine
  ----------------------------------------------------------------------------*/
void WDT_IRQHandler(void) // Timer0 interrupt subroutine 
{
	UNLOCKREG();
 	WDT->WTCR.WTIF =1; 
	WDTCOUN++;
	
	if (WDTCOUN<10) WDT->WTCR.WTR=1;	//Wait 10 times	

	LOCKREG();
	GPIOA->DOUT = 0x00;	//Toggle GPIOA_0
	Delay(10000);
	GPIOA->DOUT = 0x01;	   
}
/*----------------------------------------------------------------------------
  MAIN function
  ----------------------------------------------------------------------------*/
int32_t main (void)
{
	

	GPIOA->PMD.PMD0=1;
	Delay(1000);
	while(GPIOA->PIN&0x8000);	//Wait low signal of GPIOA_15

		
	NVIC_DisableIRQ(WDT_IRQn);	//Disable WDT interrupt
	outpw(&WDT->WTCR ,0 );		//Disable WDT 
		                             
	UNLOCKREG();		
	/* Step 1. Enable and Select WDT clock source */          
	SYSCLK->CLKSEL1.WDG_S =3;	//Select 10Khz for WDT clock source 
	SYSCLK->APBCLK.WDG_EN =1;	//Enable WDT clock source

	/* Step 2. Select Timeout Interval */
	
	WDT->WTCR.WTIS=4;			//Select level 3 (11-bit mode)
		
	/* Step 3. Enable Watchdog Timer Reset function */
	WDT->WTCR.WTRE = 1;
	
	/* Step 4. Enable WDT interrupt */
	WDT->WTCR.WTIF =1;		//Write 1 to clear for safty
	WDT->WTCR.WTIE = 1;
	NVIC_EnableIRQ(WDT_IRQn);	//Enable WDT Interrupt
	
	/* Step 5. Enable WDT module */
	WDT->WTCR.WTE = 1;		//Enable WDT
	LOCKREG();
	while(1);

}





